config/routes.rb
Rails.application.routes.draw do
  get 'users/new'
  post 'users/create'

  get 'sessions/new'

   get 'welcome/index'
   get    'login'   => 'sessions#new'
   post   'login'   => 'sessions#create'
   delete 'logout'  => 'sessions#destroy'

  resources :articles do
    resources :comments
  end
   root 'articles#index'

end

app/models/article.rb
class Article < ActiveRecord::Base
	has_many :comments
	validates :title, presence: true,
			length: {minimum: 5 }
end

app/models/comment.rb
class Comment < ActiveRecord::Base
  belongs_to :article
end

app/models/user.rb
class User < ActiveRecord::Base
	# before_save { self.email = email.downcase }
 #  validates :name,  presence: true, length: { maximum: 50 }
   VALID_EMAIL_REGEX = /\A[\w+\-.]+@[a-z\d\-.]+\.[a-z]+\z/i
  validates :email, presence: true, length: { maximum: 255 },
                    format: { with: VALID_EMAIL_REGEX },
                    uniqueness: { case_sensitive: false }
  has_secure_password
  validates :password, presence: true, length: { minimum: 6 }

  # Returns the hash digest of the given string.
  def User.digest(string)
    cost = ActiveModel::SecurePassword.min_cost ? BCrypt::Engine::MIN_COST :
                                                  BCrypt::Engine.cost
    BCrypt::Password.create(string, cost: cost)
  end
  def User.new_token
  	SecureRandom.urlsafe_base64
  end

  def remember
  	self.remember_token = User.new_token
  	update_attribute(:remember_digest, User.digest(remember_token))
  end

  def authenticated?(remember_token)
  	BCrypt::Password.new(remember_digest).is_password?(remember_token)
  end

  def forget
  	update_attribute(:remember_digest, nil)
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
	# http_basic_authenticate_with name: "user", password: "mkr5htgi",
	# 	except: [:index, :show]


	def new
		@article = Article.new
		@articles = Article.all
	end

	def login
		
	end

	def create
		# render plain: params[:article].inspect
		@article = Article.new(article_params)

		if @article.save
		redirect_to @article
			else
				render 'new'
			end
	end

	def update
		@article = Article.find(params[:id])

		if @article.update(article_params)
			redirect_to @article
		else
			render 'edit'
		end

	end

	def edit
		@article = Article.find(params[:id])
	end

	def index
		@articles = Article.all
	end

	def show
		@article = Article.find(params[:id])
	end

	def destroy
      @article = Article.find(params[:id])
      @article.destroy!
      redirect_to '/articles/new', :notice => "Your article has been deleted"
  end

	private
	def article_params
		params.require(:article).permit(:title, :text)
	end

end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
	def create
		@article = Article.find(params[:article_id])
		@comment = @article.comments.create(comment_params)
		redirect_to article_path(@article)
	end

	private
	def comment_params
		params.require(:comment).permit(:commenter, :body)
	end

end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  def new
  end

  def create
    @user = User.find_by(email: params[:session][:email])
    session[:current_user_id] = @user.id
    if @user && @user.authenticate(params[:session][:password])
      redirect_to "/articles/new"
    else
      flash.now[:danger] = 'Invalid email/password combination'
      render 'new'
    end
  end


  def destroy
    session[:user_id] = nil
  	redirect_to_root_url
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def show
    @user = User.find(params[:id])
  end

  def new
    @user = User.new
  end

  def create
    @user = User.new(user_params)
    if @user.save
    
      flash[:success] = "Welcome to the Sample App!"
      redirect_to "/sessions/new"
    else
      render 'new'
    end
  end

  private

    def user_params
      params.require(:user).permit(:name, :email, :password,
                                   :password_confirmation)
    end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/sessions_helper.rb
module SessionsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/articles/_form.html.erb
<div class="container-fluid">
      <style>
      div {
          background-color: lightgrey;
          width: 100%;
          height: 100%;
          padding: 25px;
          border: 25px solid navy;
          margin: 25px;
          text-align:center;
        }
      </style>  

<%= form_for @article do |f| %>
 
  <% if @article.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@article.errors.count, "error") %> prohibited
        this article from being saved:
      </h2>
      <ul>
        <% @article.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
 
  <p>
    <%= f.label :title %><br>
    <%= f.text_field :title %>
  </p>
 
  <p>
    <%= f.label :text %><br>
    <%= f.text_area :text %>
  </p>
 
  <p>
    <%= f.submit %>
  </p>
 
<% end %>

app/views/articles/edit.html.erb
<div class="container-fluid">
      <style>
      div {
          background-color: lightgrey;
          width: 100%;
          height: 100%;
          padding: 25px;
          border: 25px solid navy;
          margin: 25px;
          text-align:center;
        }
      </style>  

<h1>Editing article</h1>
 
<%= form_for :article, url: article_path(@article), method: :patch do |f| %>
 
  <% if @article.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@article.errors.count, "error") %> prohibited
        this article from being saved:
      </h2>
      <ul>
        <% @article.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
 
  <p>
    <%= f.label :title %><br>
    <%= f.text_field :title, size: "30x10"  %>
  </p>
 
  <p>
    <%= f.label :text %><br>
    <%= f.text_area :text, size: "90x12", size: "30x10"  %>
  </p>
 
  <p>
    <%= f.submit %>
  </p>
 
<% end %>

	<%= link_to 'Back', articles_path, :class=>"btn btn-success" %>

  </div>

app/views/articles/index.html.erb
<div class="container-fluid">
			<style>
			div {
			    background-color: lightgrey;
			    width: 100%;
			    height: 100%;
			    padding: 25px;
			    border: 25px solid navy;
			    margin: 25px;

				}
			</style>

	<%= link_to 'Create New_Blog',  sessions_new_path, :class=>"btn btn-success pull-right"  %>
	<br>
	</br>

  <button type="button" class="btn btn-primary btn-block" size="40px"><h1>Blog a Platform to share Ideas</h1></button> 
  	<br> <!-- 
<%= link_to 'New Blog', new_article_path, :class=>"btn btn-success" %> -->


<br>	
<!-- <nav class="navbar navbar-inverse"> -->
  <!-- <div class="container-fluid">
      <li class="active"><a href="#">Home</a></li>
      <li class="active"><a href="#">Title</a></li>
  </div> -->
<!-- </nav> -->

<br>
<br>

<% @articles.each do |article| %>
<div class="well">
	<h3><%= article.title %></h3>
	<%= link_to 'Show More',  "/articles/#{article.id}", :class=>"btn btn-success pull-right"  %>
	<p><%= article.text.gsub(/^(.{5,}?).*$/m,'\1...')%></p>


</div>
<%end%>
</table>

</div>

app/views/articles/new.html.erb
<div class="container-fluid">
      <style>
      div {
          background-color: lightgrey;
          width: 100%;
          height: 100%;
          padding: 25px;
          border: 25px solid navy;
          margin: 25px;
          text-align:center;
        }
      </style>  
<%= link_to 'Logout', articles_path, :class=>"btn btn-success pull-right" %>
<h1> Write your idea </h1>

<%= form_for :article, url: articles_path do |f| %>
 
  <% if @article.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@article.errors.count, "error") %> prohibited
        this article from being saved:
      </h2>
      <ul>
        <% @article.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
 
  <p>
    <%= f.label :title %>
    </button><br>
    <%= f.text_field :title, size: "30x10"   %>
  </p>
 
  <p>
    <%= f.label :text %><br>
    <%= f.text_area :text, size: "90x12" %>
  </p>
 
  <p>
    <%= f.submit   %>
  </p>
 
<% end %>
 
<%= link_to 'Back', articles_path, :class=>"btn btn-danger" %>
<%= link_to 'Home', articles_path, :class=>"btn btn-success" %>
<h2> List of Articles </h2>
<% @articles.each do |article| %>
<div class="well">
  <h3><%= article.title %></h3>
  <p><%= article.text.gsub(/^(.{50,}?).*$/m,'\1...')%>
</p>
  <td><%= link_to 'Show More' , article_path(article), :class=>"btn btn-success pull-center"%></td><br>&nbsp;
  <td><%= link_to 'Edit', edit_article_path(article), :class=>"btn btn-success pull-left" %></td>&nbsp;
  <td><%= link_to 'Delete', article,method: :delete, :class=>"btn btn-danger pull-right" %></td>
</div>
<%end%>


</div>

app/views/articles/show.html.erb
<div class="container-fluid">
      <style>
      div {
          background-color: lightgrey;
          width: 100%;
          height: 100%;
          padding: 25px;
          border: 25px solid navy;
          margin: 25px;
          text-align:center;
        }
      </style>  

<%= link_to 'Logout', articles_path, :class=>"btn btn-success pull-right" %>
<p>
  
  <strong>Title:</strong>
  <%= @article.title %>
</p>
 
<p>
  <strong>Text:</strong>
  <%= @article.text %>
</p>
 
<h2>Comments</h2>
<% @article.comments.each do |comment| %>
  <p>
    <strong>Commenter:</strong>
    <%= comment.commenter %>
  </p>
 
  <p>
    <strong>Comment:</strong>
    <%= comment.body %>
  </p>
<% end %>
 
<h3>Add a comment:</h3>
<%= form_for([@article, @article.comments.build]) do |f| %>
  <p>
    <%= f.label :commenter %><br>
    <%= f.text_field :commenter %>
  </p>
  <p>
    <%= f.label :body %><br>
    <%= f.text_area :body %>
  </p>
  <p>
    <%= f.submit %>
  </p>
<% end %>
 
<%= link_to 'Edit', edit_article_path(@article), :class=>"btn btn-success"%>
<%= link_to 'Home', articles_path, :class=>"btn btn-success" %>

</div>

app/views/comments/_comment.html.erb
<p>
<strong>Commenter:</strong>
<%= comment.commenter %>
</p>

<p>
<strong>Comment:</strong>
<%= comment.body %>
</p>

<p>
	<%= link_to 'Destroy Comment', [comment.article, comment]
			method:delete,
			data: {confirm: 'Are you sure?'} %>

</p>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>App</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="http://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.0/jquery.min.js"></script>
  <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"></script>
</head>
<body>

<%= yield %>

</body>
</html>

app/views/users/new.html.erb
<div class="container-fluid">
<br>
<button type="button" class="btn btn-primary btn-block" size="40px"><h1>Blog a Platform to share Ideas</h1></button> 
  	<br>
      <style>
      </style> 
	<div class="row">
	  <div class="col-md-6 col-md-offset-3">
	    <%= form_for(@user, :url=> users_create_path) do |f| %>

	      <%= f.label :email %>
	      <%= f.email_field :email, class: 'form-control' %>

	      <%= f.label :password %>
	      <%= f.password_field :password, class: 'form-control' %><br>
	      <%= f.label :password_confirmation %>
	      <%= f.password_field :password_confirmation, class: 'form-control' %><br>

	      <%= f.submit "sign up", class: "btn btn-primary" %>
	    <% end %>
	    
	  </div>
	 </div>
	 
</div>
<br>
<br>
<br>
<br>
<br>
<br>
<br>


<div id="footer">	 
<div style="background-color:grey; color:white; padding:20px;">

<h2>About Us</h2>

<p>London is the capital city of England. It is the most populous city in the United Kingdom, with a metropolitan area of over 13 million inhabitants.</p>
<p>Standing on the River Thames, London has been a major settlement for two millennia, its history going back to its founding by the Romans, who named it Londinium.</p>
</div> 

app/views/welcome/index.html.erb
<h1>Hello, Rails!</h1>
<%= link_to 'My Blog', controller: 'articles' %>